/*********************************************************************************
This sample demonstrates loading of metadata if the standard way (see GeneralDemo)
is not suitable for some reason.
**********************************************************************************/
package fillmetadatademo;

import com.adbs.ast.*;
import com.adbs.metadata.*;
import com.adbs.querybuilder.*;
import com.adbs.syntax.*;
import java.awt.Cursor;
import javax.swing.JOptionPane;
import java.util.logging.Level;
import java.util.logging.Logger;


public class MainFrame extends javax.swing.JFrame
{
	private static final long serialVersionUID = 1L;

    public MainFrame()
	{
        initComponents();

		// center window on the desktop
		setLocationRelativeTo(null);

		//set up query builder
		
		queryBuilder1.setSyntaxProvider(new UniversalSyntaxProvider());

		MetadataTreeOptions mto = queryBuilder1.getMetadataTreeOptions();
		mto.setGroupingType(ObjectsGroupingType.DatabaseSchema);
		mto.setSortingType(ObjectsSortingType.SchemaTypeName);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        queryBuilder1 = new com.adbs.querybuilder.QueryBuilder();
        jButtonFillUsingEvents = new javax.swing.JButton();
        jButtonDirectFilling = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextArea1 = new javax.swing.JTextArea();
        jScrollPane2 = new javax.swing.JScrollPane();
        jTextArea2 = new javax.swing.JTextArea();
        jScrollPane3 = new javax.swing.JScrollPane();
        jTextArea3 = new javax.swing.JTextArea();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Fill Metadata Demo");

        jButtonFillUsingEvents.setText("Fill metadata using special event");
        jButtonFillUsingEvents.setActionCommand("Fill metadata using event");
        jButtonFillUsingEvents.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonFillUsingEventsActionPerformed(evt);
            }
        });

        jButtonDirectFilling.setText("Direct filling of MetadataContainer");
        jButtonDirectFilling.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonDirectFillingActionPerformed(evt);
            }
        });

        jTextArea1.setBackground(java.awt.SystemColor.info);
        jTextArea1.setColumns(20);
        jTextArea1.setEditable(false);
        jTextArea1.setFont(new java.awt.Font("SansSerif", 0, 11)); // NOI18N
        jTextArea1.setLineWrap(true);
        jTextArea1.setRows(2);
        jTextArea1.setText("This method demonstrates manual filling of metadata structure using GetObjectsNamesEvent event of the EventMetadataProvider.");
        jTextArea1.setWrapStyleWord(true);
        jTextArea1.setMargin(new java.awt.Insets(2, 5, 2, 2));
        jScrollPane1.setViewportView(jTextArea1);

        jTextArea2.setBackground(java.awt.SystemColor.info);
        jTextArea2.setColumns(20);
        jTextArea2.setEditable(false);
        jTextArea2.setFont(new java.awt.Font("SansSerif", 0, 11)); // NOI18N
        jTextArea2.setLineWrap(true);
        jTextArea2.setRows(2);
        jTextArea2.setText("This method demonstrates the direct access to the internal matadata objects collection (MetadataContainer).");
        jTextArea2.setWrapStyleWord(true);
        jTextArea2.setMargin(new java.awt.Insets(2, 5, 2, 2));
        jScrollPane2.setViewportView(jTextArea2);

        jTextArea3.setBackground(new java.awt.Color(255, 236, 236));
        jTextArea3.setEditable(false);
        jTextArea3.setFont(new java.awt.Font("SansSerif", 0, 11)); // NOI18N
        jTextArea3.setRows(2);
        jTextArea3.setText("This sample demonstrates loading of metadata if the standard way (see GeneralDemo) is not suitable for some reason.");
        jTextArea3.setMargin(new java.awt.Insets(2, 5, 2, 2));
        jScrollPane3.setViewportView(jTextArea3);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane3, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 680, Short.MAX_VALUE)
                    .addComponent(queryBuilder1, javax.swing.GroupLayout.DEFAULT_SIZE, 680, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jButtonFillUsingEvents, javax.swing.GroupLayout.DEFAULT_SIZE, 197, Short.MAX_VALUE)
                            .addComponent(jButtonDirectFilling, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 477, Short.MAX_VALUE)
                            .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 477, Short.MAX_VALUE))))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane3, javax.swing.GroupLayout.PREFERRED_SIZE, 36, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButtonFillUsingEvents, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jButtonDirectFilling, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(queryBuilder1, javax.swing.GroupLayout.DEFAULT_SIZE, 384, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

	private void jButtonFillUsingEventsActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButtonFillUsingEventsActionPerformed
	{//GEN-HEADEREND:event_jButtonFillUsingEventsActionPerformed
		//////////////////////////////////////////////////////////////////////////
		/// This method demonstrates manual filling of metadata structure using
		/// GetObjectsNamesEvent event of the EventMetadataProvider.
		//////////////////////////////////////////////////////////////////////////

		// clean up
		queryBuilder1.setSQL("");
		queryBuilder1.getMetadataContainer().clear();

		try
		{
			setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

			EventMetadataProvider ep = new EventMetadataProvider();

			ep.addGetObjectsNamesEventListener(new GetObjectsNamesAdapter()
			{
				@Override
				public void getTables(GetObjectNamesEvent event)
				{
					for (int i = 0; i < 5 ; i++)
					{
						event.databaseObjects.add("db.sch.Table_" + String.valueOf(i));
					}
				}

				@Override
				public void getViews(GetObjectNamesEvent event)
				{
					for (int i = 0; i < 5 ; i++)
					{
						event.databaseObjects.add("db.sch.View_" + String.valueOf(i));
					}
				}

				@Override
				public void getProcedures(GetObjectNamesEvent event)
				{
					for (int i = 0; i < 5 ; i++)
					{
						event.databaseObjects.add("db.sch.Procedure_" + String.valueOf(i));
					}
				}

				@Override
				public void getSynonyms(GetObjectNamesEvent event)
				{
					for (int i = 0; i < 5 ; i++)
					{
						event.databaseObjects.add("db.sch.Synonym_" + String.valueOf(i));
					}
				}

				@Override
				public void getFields(GetFieldsEvent event)
				{
					for (int i = 0; i < 5; i++)
					{
						MetadataObject mo = event.metadataObject;
						MetadataField mf = mo.getFields().addField(mo.getNameStr() +"_col_" + String.valueOf(i));

						if (i == 0)
						{
							mf.setPrimaryKey(true);
						}
					}
				}

				@Override
				public void getRelations(GetRelationsEvent event)
				{
					if (event.metadataObject.getNameStr().equals("Table_1"))
					{
						MetadataRelation r = event.metadataObject.getRelations().add();

						r.getKeyFields().addField("Table_1_col_1");
						r.getChildTable().parse("db.sch.Table_2");
						r.getChildFields().addField("Table_2_col_1");
					}
					if (event.metadataObject.getNameStr().equals("Table_3"))
					{
						MetadataRelation r = event.metadataObject.getRelations().add();

						r.getKeyFields().addField("Table_3_col_2");
						r.getChildTable().parse("db.sch.Table_2");
						r.getChildFields().addField("Table_2_col_2");
					}
				}
			});

			queryBuilder1.setOfflineMode(false);
			queryBuilder1.setMetadataProvider(ep);

			queryBuilder1.refreshMetadata();
		}
		catch (Exception ex)
		{
			Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
			JOptionPane.showMessageDialog(this, ex.getMessage());
		}
		finally
		{
			setCursor(Cursor.getDefaultCursor());
		}
	}//GEN-LAST:event_jButtonFillUsingEventsActionPerformed

	private void jButtonDirectFillingActionPerformed(java.awt.event.ActionEvent evt)//GEN-FIRST:event_jButtonDirectFillingActionPerformed
	{//GEN-HEADEREND:event_jButtonDirectFillingActionPerformed
		MetadataTable t;
		MetadataRelation r;

		// clean up
		queryBuilder1.setSQL("");
		queryBuilder1.getMetadataContainer().clear();

		setCursor(Cursor.getPredefinedCursor(Cursor.WAIT_CURSOR));

		// prepare QueryBuilder
		queryBuilder1.setOfflineMode(true);
		queryBuilder1.setMetadataProvider(null);
		
		queryBuilder1.getMetadataContainer().beginUpdate();

		try
		{
			// prepare metadata for table "Orders"
			t = queryBuilder1.getMetadataContainer().addTable("dbo", "Orders", false, null);
			// fields
			t.getFields().addField("OrderId");
			t.getFields().addField("CustomerId");
			// foreign keys
			r = t.getRelations().add();
			r.getKeyFields().add("OrderId");
			r.setChildSchemaStr("dbo");
			r.setChildNameStr("Order Details");
			r.getChildFields().add("OrderId");

			// prepare metadata for table "Order Details"
			t = queryBuilder1.getMetadataContainer().addTable("dbo", "Order Details", false, null);
			// fields
			t.getFields().addField("OrderId");
			t.getFields().addField("ProductId");
		}
		catch (Exception ex)
		{
			Logger.getLogger(this.getClass().getName()).log(Level.SEVERE, null, ex);
			JOptionPane.showMessageDialog(this, ex.getMessage());
		}
		finally
		{
			queryBuilder1.getMetadataContainer().endUpdate();
			
			setCursor(Cursor.getDefaultCursor());
		}
	}//GEN-LAST:event_jButtonDirectFillingActionPerformed

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonDirectFilling;
    private javax.swing.JButton jButtonFillUsingEvents;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JScrollPane jScrollPane3;
    private javax.swing.JTextArea jTextArea1;
    private javax.swing.JTextArea jTextArea2;
    private javax.swing.JTextArea jTextArea3;
    private com.adbs.querybuilder.QueryBuilder queryBuilder1;
    // End of variables declaration//GEN-END:variables

}
